compile 1.5 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061
  1. #!/bin/bash
  2. set -eo pipefail
  3. SUCCESS_TXT="${GREEN}[SUCCESS]${NC}"
  4. src_file=$1
  5. exe_file=$(basename "${src_file%.*}")
  6. if [[ -z "$MACHINE" ]]; then
  7. echo "Must provide MACHINE for compile"
  8. exit 1
  9. fi
  10. if [[ "$MACHINE" == "Windows" ]]; then
  11. exe_file=$(basename "${src_file%.*}".exe)
  12. fi
  13. if [[ -z "$src_file" ]]; then
  14. echo "Must provide \$1 for compile"
  15. exit 1
  16. fi
  17. if [[ -z "$CPP_INCLUDE_DIR" ]]; then
  18. echo "Must provide CPP_INCLUDE_DIR in environment"
  19. exit 1
  20. fi
  21. if [[ -z "$CPP" ]]; then
  22. echo "Must provide CPP in environment"
  23. exit 1
  24. fi
  25. rm -f "$exe_file"
  26. EXTRA_ARGS=""
  27. if [[ "$CPP" == "cl.exe" ]]; then
  28. echo "Compiling $src_file, running:" "$CPP" "$CPP_STANDARD" "-F268435456" "-EHsc" "-O2" -I"${CPP_INCLUDE_DIR}" -Fe"$exe_file" "$src_file"
  29. "$CPP" "$CPP_STANDARD" "-F268435456" "-EHsc" "-O2" -I"${CPP_INCLUDE_DIR}" -Fe"$exe_file" "$src_file"
  30. else
  31. "$CPP" --version
  32. dir=$(dirname "$CPP")
  33. if [[ "$dir" == *"/bin" ]] || [[ "$MACHINE" == "Windows" ]]; then
  34. EXTRA_ARGS="${EXTRA_ARGS} -static"
  35. fi
  36. echo "Compiling $src_file, running:" "$CPP" "$CPP_OPTS" "$CPP_STANDARD" -Wpedantic -Werror -I"${CPP_INCLUDE_DIR}""$EXTRA_ARGS" -o"$exe_file" -O2 "$src_file"
  37. eval "$CPP" "$CPP_OPTS" "$CPP_STANDARD" -Wpedantic -Werror -I"${CPP_INCLUDE_DIR}""$EXTRA_ARGS" -o"$exe_file" -O2 "$src_file"
  38. fi
  39. rm -f ./*.o ./*.obj
  40. if [ ! -f "$exe_file" ]; then
  41. echo "Compilation failed: file $exe_file not found"
  42. exit 1
  43. fi
  44. echo -e "${SUCCESS_TXT} $src_file compiled\n"
  45. if [[ "$2" == "--check-only" ]]; then
  46. rm -rf "$exe_file"
  47. fi